const { ami } = require('../../../index')
const moment = require('moment');
const _ = require('underscore')

exports.filaAddAtendimento = async (io, ev) => {
  console.log('filaAddAtendimento', ev)
    const fila = ev.fila
    const evento = {
      data: ev.data,
      fila: fila,
      sentido: 'Entrante',
      AtendimentoId: ev.atendimentoId,
      numero: ev.numero,
      nome: ev.nome
    }
    const filaAmi = ami.filas.find(f => f.name === fila)
    if (filaAmi) {
        const atendimentoExistente = filaAmi.AtendimentosAguardando.find(at => at.AtendimentoId === ev.atendimentoId)
        if (atendimentoExistente) return
        evento.posicaoInicial = filaAmi.AtendimentosAguardando.length + 1
        filaAmi.AtendimentosAguardando.push(evento)
    }

    io.to(`fila_${fila}`).emit('FilaAtendimentoAguardandoAdicionado', evento)
}

exports.removeAtendimentoNaFila = async (io, ev) => {
  console.log('removeAtendimentoNaFila', ev)
    const fila = ev.fila
    const filaAmi = ami.filas.find(f => f.name === fila)
    if (filaAmi) {
      const evento = {
        data: ev.data,
        fila: fila,
        sentido: 'Entrante',
        AtendimentoId: ev.atendimentoId,
        agente: ev.agente,
        nome: ev.nome,
        numero: ev.numero
      }
      const agente = filaAmi.agentes.find(agente => agente.nome === ev.agente);
      if (ev.tipo === 'atendido') {
        console.log('ATENDIDO', evento)
        const index = filaAmi.AtendimentosAguardando.findIndex(at => at.atendimentoId === ev.atendimentoId || at.AtendimentoId === ev.atendimentoId);
        if (index !== -1) {
          filaAmi.AtendimentosAguardando.splice(index, 1)
        }
        const ultimaMensagem = { data: moment().format('DD/MM/YYYY HH:mm:ss'), sentido: 'entrante' }
          
          const indexAtendimento = filaAmi.AtendimentosEmAndamento.findIndex(
            (at) => at.dados.AtendimentoId === ev.atendimentoId || at.dados.atendimentoId === ev.atendimentoId
          )
          console.log('indexAtendimento', indexAtendimento)
          if (indexAtendimento === -1) {
            console.log('Adicionando atendimento em andamento')
            filaAmi.AtendimentosEmAndamento.push({ dados: evento, ultimaMensagem, primeira_resposta: true })
            filaAmi.TotalAtendimentosEntrantes++
          }
          if (agente) {
            console.log('Existe agente', agente)
            const indexAtendimentoAgente = agente.atendimento_ativo.findIndex(
              (at) => at.dados.AtendimentoId === ev.atendimentoId || at.dados.atendimentoId === ev.atendimentoId
            )
            if (indexAtendimentoAgente === -1) {
              console.log('Adicionando atendimento em andamento ao agente')
              agente.atendimento_ativo.push({ dados: evento, ultimaMensagem, primeira_resposta: true })
              agente.atendimentos_recebidos++
            }
          }
          
          io.to(`fila_${fila}`).emit('FilaAtendimentoAguardandoRemovido', evento)
      }
      if (['encerramento', 'transferencia'].includes(ev.tipo)) {
        filaAmi.TotalAtendimentosEncerrados++
        const index = filaAmi.AtendimentosEmAndamento.findIndex(
          (at) => at.dados.AtendimentoId === ev.atendimentoId || at.dados.atendimentoId === ev.atendimentoId
        )
        if (index !== -1) {
          filaAmi.AtendimentosEmAndamento.splice(index, 1)
        }
        if (agente) {
          const indexAgente = agente.atendimento_ativo.findIndex(
            (at) => at.dados.AtendimentoId === ev.atendimentoId || at.dados.atendimentoId === ev.atendimentoId
          )
          if (indexAgente !== -1) {
            agente.atendimento_ativo.splice(indexAgente, 1)
          }
        }
        
        io.to(`fila_${fila}`).emit('FilaAtendimentoEncerrado', evento)

        // if (ev.tipo === 'transferencia' && ev.transferTo) {
        //   const evento = {
        //     fila: ev.transferTo,
        //     sentido: 'Entrante',
        //     AtendimentoId: ev.atendimentoId,
        //   }
        // filaAmi.TotalAtendimentosEntrantes++
        // // agente.atendimentos_recebidos++
        // io.to(`fila_${ev.transferTo}`).emit('FilaNovoAtendimento', evento)
        // }
      }
    }
}

exports.novaMensagemAgente = async (io, ev) => {
  console.log('novaMensagemAgente', ev)
    const fila = ev.fila
    const evento = {
        data: ev.data,
        fila: fila,
        sentido: ev.tipo,
        AtendimentoId: ev.atendimentoId,
        agente: ev.agente,
        nome: ev.nome,
        subtipo: ev.subtipo
    }

    const filaAmi = ami.filas.find(f => f.name === fila)
    if (filaAmi) {
        const agente = filaAmi.agentes.find(agente => agente.nome === ev.agente);
        let atendimento = filaAmi.AtendimentosEmAndamento.find(
          (at) => at.dados.AtendimentoId === ev.atendimentoId || at.dados.atendimentoId === ev.atendimentoId
        )
        if (agente) {
          let agenteAtendimento = agente.atendimento_ativo.find(
            (at) => at.dados.AtendimentoId === ev.atendimentoId || at.dados.atendimentoId === ev.atendimentoId)
          if (atendimento.ultimaMensagem.sentido === 'entrante' && ev.tipo === 'sainte') {
            if (atendimento.primeira_resposta) {
              const tempoResposta = moment().diff(
                moment(atendimento.dados.data),
                'seconds'
              )
                agenteAtendimento.primeira_resposta = false
                agente.tempo_primeira_resposta += tempoResposta
                agente.total_primeira_resposta++
                agente.tempo_total_resposta += tempoResposta
                agente.total_mensagens_resposta++
              if (tempoResposta > filaAmi.tmaxr) {
                agente.tmaxr = tempoResposta
              }
              if (tempoResposta > filaAmi.tmaxpr) {
                agente.tmaxpr = tempoResposta;
              } 
            } else {
              const tempoResposta = moment().diff(
                 moment(atendimento.ultimaMensagem.data, 'DD/MM/YYYY HH:mm:ss'),
                'seconds'
              )
              agente.tempo_total_resposta += tempoResposta
              agente.total_mensagens_resposta++
              if (tempoResposta > filaAmi.tmaxr) {
                agente.tmaxr = tempoResposta
              }
            }
          }
          agenteAtendimento.ultimaMensagem = {
            sentido: ev.tipo,
            data: moment().format('DD/MM/YYYY HH:mm:ss'),
          }
        }
        if (atendimento.ultimaMensagem.sentido === 'entrante' && ev.tipo === 'sainte') {
          if (atendimento.primeira_resposta) {
            const tempoResposta = moment().diff(
              moment(atendimento.dados.data),
              'seconds'
            )
            atendimento.primeira_resposta = false
            filaAmi.tempo_primeira_resposta += tempoResposta
            filaAmi.total_primeira_resposta++
            filaAmi.tempo_total_resposta += tempoResposta
            filaAmi.total_mensagens_resposta++
            if (tempoResposta > filaAmi.tmaxr) {
              filaAmi.tmaxr = tempoResposta
            }
            if (tempoResposta > filaAmi.tmaxpr) {
              filaAmi.tmaxpr = tempoResposta;
            } 

          } else {
            const tempoResposta = moment().diff(
              moment(atendimento.ultimaMensagem.data, 'DD/MM/YYYY HH:mm:ss'),
              'seconds'
            )
            filaAmi.tempo_total_resposta += tempoResposta
            filaAmi.total_mensagens_resposta++
            if (tempoResposta > filaAmi.tmaxr) {
              filaAmi.tmaxr = tempoResposta
            }
          }
        }
          atendimento.ultimaMensagem = {
            sentido: ev.tipo,
            data: moment().format('DD/MM/YYYY HH:mm:ss'),
          }
        if (ev.tipo === 'sainte') filaAmi.MsgEnviadas++
        else filaAmi.MsgRecebidas++
    }

    io.to(`fila_${fila}`).emit('FilaNovaMensagem', evento)
}

exports.filaNovaMensagem = async (io, ev) => {
  console.log('filaNovaMensagem', ev)
    const fila = ev.fila
    const evento = {
        data: ev.data,
        fila: fila,
        sentido: 'entrante',
        AtendimentoId: ev.atendimentoId,
        agente: ev.agente,
        nome: ev.nome
    }

    const filaAmi = ami.filas.find(f => f.name === fila)
    if (filaAmi) {
        let atendimento = filaAmi.AtendimentosEmAndamento.find(
            (at) => at.dados.AtendimentoId === ev.atendimentoId || at.dados.atendimentoId === ev.atendimentoId)
        if (atendimento) {
          const indexAtendimento = filaAmi.AtendimentosEmAndamento.findIndex(
            (at) => at.dados.AtendimentoId === ev.atendimentoId || at.dados.atendimentoId === ev.atendimentoId
          )
          filaAmi.AtendimentosEmAndamento[indexAtendimento].ultimaMensagem = {
              sentido: 'entrante',
              data: moment().format('DD/MM/YYYY HH:mm:ss'),
          }
        }
        const agente = filaAmi.agentes.find(agente => agente.nome === ev.agente)
        if (agente) {
        let agenteAtendimento = agente.atendimento_ativo.find(
          (at) => at.dados.AtendimentoId === ev.atendimentoId || at.dados.atendimentoId === ev.atendimentoId)
          if (agenteAtendimento) {
            const indexAtendimentoAgente = agente.atendimento_ativo.findIndex(
              (at) => at.dados.AtendimentoId === ev.atendimentoId || at.dados.atendimentoId === ev.atendimentoId
            )
            agente.atendimento_ativo[indexAtendimentoAgente].ultimaMensagem = {
                sentido: 'entrante',
                data: moment().format('DD/MM/YYYY HH:mm:ss'),
            }
          }
        }
        filaAmi.MsgRecebidas++
    }

    io.to(`fila_${fila}`).emit('FilaNovaMensagem', evento)
}

exports.filaNovoAtendimento = async (io, ev) => {
  console.log('filaNovoAtendimento', ev)
    const fila = ev.fila
    const evento = {
        data: ev.data,
        fila: fila,
        sentido: 'Entrante',
        AtendimentoId: ev.atendimentoId,
        numero: ev.numero,
        nome: ev.nome
    }

    const filaAmi = ami.filas.find(f => f.name === fila)
    if (filaAmi) {
        if (ev.numero) {
          filaAmi.clientes_atendidos.push(ev.numero)
        }
        filaAmi.clientes_atendidos = _.uniq(filaAmi.clientes_atendidos)
    }

    io.to(`fila_${fila}`).emit('FilaNovoAtendimento', evento)
}

exports.agenteAddAtendimento = async (io, ev) => {
  console.log('agenteAddAtendimento', ev)
    const fila = ev.fila
    const evento = {
        data: ev.data,
        fila: fila,
        sentido: 'Sainte',
        AtendimentoId: ev.atendimentoId,
        agente: ev.agente,
        numero: ev.numero,
        nome: ev.nome
    }

    const filaAmi = ami.filas.find(f => f.name === fila)
    if (filaAmi) {
      const agente = filaAmi.agentes.find(agente => agente.nome === ev.agente);
      if (ev.numero) {
          filaAmi.clientes_atendidos.push(ev.numero)
        }
        filaAmi.clientes_atendidos = _.uniq(filaAmi.clientes_atendidos)

        filaAmi.TotalAtendimentosSaintes++

        const primeira_resposta = false
        const ultimaMensagem = { data: moment().format('DD/MM/YYYY HH:mm:ss'), sentido: 'sainte' }
        filaAmi.AtendimentosEmAndamento.push({ dados: evento, ultimaMensagem, primeira_resposta })
        if (agente) {
          agente.atendimentos_efetuados++
        //   await ami.addAgente(fila, { name: ev.agente, status: 999 })
          agente.atendimento_ativo.push({ dados: evento, ultimaMensagem, primeira_resposta })
        }
    }
    io.to(`fila_${fila}`).emit('FilaNovoAtendimento', evento)
}